#include "mbed.h"
#include "TextLCD.h"

Serial pc(USBTX, USBRX);
Serial HC05(D9, D7);
DigitalOut KEY(D10);
InterruptIn button2(SW2);
InterruptIn button3(SW3);
TextLCD lcd(D2, D3, D4, D5, D6, D8);

char str[50];
char pwd[15];
int n[4];
int cnt = 0;

void mode()
{
    if (KEY == 1.0)
    {
        KEY = 0;
    }
    else
    {
        KEY = 1.0;
    }
    HC05.printf("AT+RESET\r\n");
}

void show()
{
    int o;
    char p;
    HC05.printf("AT+PSWD?\r\n");
    while (HC05.getc() != ':')
    {
    }
    for (o = 0; o < 6; o++)
    {
        p = HC05.getc();
        pc.printf("%c", p);
        lcd.putc(p);
    }
    HC05.printf("AT+ADDR?\r\n");
    while (HC05.getc() != ':')
    {
    }
    for (o = 0; o < 16; o++)
    {
        p = HC05.getc();
        pc.printf("%c", p);
        lcd.putc(p);
    }
    cnt++;
    if (cnt == 2)
    {
        cnt = 0;
        lcd.cls();
    }
}

int main()
{
    int i = 0;
    int j = 0;
    pc.baud(115200);
    HC05.baud(38400);
    pc.printf("Begin test\r\n");
    srand(time(NULL));
    for (j = 0; j < 4; j++)
    {
        n[j] = rand() % 10;
    }
    sprintf(pwd, "AT+PSWD=%d%d%d%d\0", n[0], n[1], n[2], n[3]);
    HC05.printf("%s\r\n", pwd);
    KEY = 1.0;
    button2.rise(&mode);
    button3.rise(&show);
    while (1)
    {
        if (pc.readable())
        {
            char c = pc.getc();
            if (c != '\r' && c != '\n')
            {
                pc.printf("%c", c);
                str[i++] = c;
            }
            else
            {
                pc.printf("(%d)\r\n", c);
                str[i] = 0;
                i = 0;
                HC05.printf("%s\r\n", str);
            }
        }
        while (HC05.readable())
        {
            char c = HC05.getc();
            pc.printf("%c", c);
        }
        wait(.001);
    }
}
