#include "mbed.h"

Serial pc(USBTX, USBRX);
Serial HC05(D9, D7);
DigitalOut KEY(D10);
InterruptIn button(SW2);
InterruptIn button1(SW3);

char str[50];
int R;

void mode()
{
    if (KEY == 1.0)
        KEY = 0;
    else
        KEY = 1.0;
    HC05.printf("AT+RESET\r\n");
}

void RPCPY()
{

    if (R == 0)
        R = 1;
    else
        R = 0;
}

int main()
{
    int i = 0;
    pc.baud(115200);
    HC05.baud(38400);
    pc.printf("Please Select Slave Address to Bind !!!\r\n");
    pc.printf("Please Enter The Corresponding Password !!!\r\n");
    HC05.printf("AT\r\n");
    KEY = 1.0;
    R = 0;
    button.rise(&mode);
    button1.rise(&RPCPY);
    while (1)
    {
        if (R == 0)
        {
            if (pc.readable())
            {
                char c = pc.getc();
                if (c != '\r' && c != '\n')
                {
                    pc.printf("%c", c);
                    str[i++] = c;
                }
                else
                {
                    pc.printf("(%d)\r\n", c);
                    str[i] = 0;
                    i = 0;
                    HC05.printf("%s\r\n", str);
                }
            }
        }
        else
        {
            for (i = 0; i < 20; i++)
            {
                str[i] = pc.getc();
                str[i + 1] = 0;
            }
            HC05.printf("%s\r\n", str);
            pc.printf("%s\r\n", str);
        }
        while (HC05.readable())
        {
            char c = HC05.getc();
            pc.printf("%c", c);
        }
        wait(.001);
    }
}