#include "mbed.h"
#include "mbed_rpc.h"
#include "TextLCD.h"

Serial pc(USBTX, USBRX);
Serial HC05(D9, D7);
DigitalOut KEY(D10);
InterruptIn button2(SW2);
InterruptIn button3(SW3);
RpcDigitalOut myled1(LED1, "myled1");
RpcDigitalOut myled2(LED2, "myled2");
RpcDigitalOut myled3(LED3, "myled3");
TextLCD lcd(D2, D3, D4, D5, D6, D8);

char str[50];
char pwd[15];
int p[4];
int cnt = 0;

void mode()
{
    if (KEY == 1.0)
        KEY = 0;
    else
        KEY = 1.0;
    HC05.printf("AT+RESET\r\n");
}

void show()
{
    int o;
    char p;
    if (KEY == 1)
    {
        HC05.printf("AT+PSWD?\r\n");
        while (HC05.getc() != ':')
        {
        }
        for (o = 0; o < 6; o++)
        {

            p = HC05.getc();

            lcd.putc(p);
        }
        HC05.printf("AT+ADDR?\r\n");
        while (HC05.getc() != ':')
        {
        }
        for (o = 0; o < 16; o++)
        {
            p = HC05.getc();
            lcd.putc(p);
        }
        cnt++;
        if (cnt == 2)
        {
            cnt = 0;
            lcd.cls();
        }
    }
    else
    {
        myled1.write(0);
        myled2.write(0);
        myled3.write(0);
    }
}

int main()
{
    int i = 0;
    int j = 0;
    int k = 0;
    char buf[64], outbuf[64];
    pc.baud(115200);
    HC05.baud(38400);
    pc.printf("Begin test\r\n");
    srand(time(NULL));
    for (j = 0; j < 4; j++)
    { //password generator
        p[j] = rand() % 10; //random OK
    }
    sprintf(pwd, "AT+PSWD=%d%d%d%d\0", p[0], p[1], p[2], p[3]); //setting string
    HC05.printf("%s\r\n", pwd); //setting the password, return OK
    KEY = 1.0;
    button2.rise(&mode); //AT <--> Comm
    button3.rise(&show); //PSWD & ADDR
    while (1)
    { //slave just receive the information
        if (pc.readable())
        { //another setting requirment
            char c = pc.getc();
            if (c != '\r' && c != '\n')
            {
                pc.printf("%c", c);
                str[i++] = c;
            }
            else
            {
                pc.printf("(%d)\r\n", c);
                str[i] = 0;
                i = 0;
                HC05.printf("%s\r\n", str);
            }
        }
        while (HC05.readable())
        { //receive command from PC or another HC05
            char c = HC05.getc();
            if (KEY == 1)
                pc.printf("%c", c); //KEY=0,1 print back receive word
            else
            { //KEY=0 Communication mode
                HC05.printf("%c", c);
                if (c != '\r' && c != '\n')
                {
                    buf[k++] = c;
                }
                else
                {
                    buf[k] = 0;
                    k = 0;
                    RPC::call(buf, outbuf);
                    HC05.printf("%s\r\n", outbuf);
                }
            }
        }
        wait(.001);
    }
}
